///////////////////////////////////////
//
// Sunburst of Budgeted Dimension
//
// Module/Controller
// 

var a = angular.module("budgetApp", [], function($interpolateProvider) {
            $interpolateProvider.startSymbol('[[');
            $interpolateProvider.endSymbol(']]');
        }
    );

var datafactory = a.factory('datafactory', function($http, $q) {

    return {
        getBudgetData : function(year) {
            var deferred = $q.defer();

            var filename;

            if (year==2012) {
                filename = 'budget2012.json';
            } else if (year==2013) { 
                filename = 'budget2013.json';
            } else if (year==2014) { 
                filename = 'budget2014.json';
            }

            if(filename) { 
                $http.get(filename).success(function(data) {
                    deferred.resolve(data);
                }).error(function(){
                    console.log('error loading '+filename);
                    deferred.reject();
                });

                return deferred.promise;
            } else {
                console.log('error with invalid year: '+year);
            }
        }
    }
});

function BudgetController($scope,datafactory) {
    $scope.initialize = function() {
        $scope.budget_year = 2012;
        datafactory.getBudgetData($scope.budget_year).then(
            function(data) { 
                $scope.budgetData = data;
            }
        );
    }
    $scope.update_budget_year = function(year) { 
        $scope.budget_year = year;
        datafactory.getBudgetData($scope.budget_year).then(
            function(data) { 
                $scope.budgetData = data;
            }
        );
    }
}

// the first few arguments of the list should correspond to the Angular-namespace stuff to feed to BudgetController
var c = a.controller("BudgetController", ["$scope", "datafactory", BudgetController]);
